using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.Common;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Configuration;

namespace ADODOTNET2
{
    public partial class frmDbProvider : Form
    {
        public frmDbProvider()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.dataGridView1.DataSource = DbProviderFactories.GetFactoryClasses();
        }

        private void button2_Click(object sender, EventArgs e)
        {

            DbConnection conn = null;

            string strConnectionString = ADODOTNET2.Properties.Settings.Default.NorthwindConnectionString;
            
            DbProviderFactory f = DbProviderFactories.GetFactory("System.Data.SqlClient");
            conn = f.CreateConnection();
            conn.ConnectionString = strConnectionString;

            this.label1.Text = conn.ConnectionString.ToString();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            try
            {
                // see this method in the example above
                DbProviderFactory f = DbProviderFactories.GetFactory("System.Data.SqlClient");
                // if our factory supports creating a DbConnection, return it.
                if (f.CanCreateDataSourceEnumerator)
                {
                    DbDataSourceEnumerator enu = f.CreateDataSourceEnumerator();
                    DataTable t = enu.GetDataSources();
                    // uses chooses a Data Row r
                    //DataRow r = t.Rows[0];
                    //string dataSource = (string)r["ServerName"];
                    //if (r[InstanceName] != null)
                    //    dataSource += ("\\" + r["InstanceName"]);
                    //// this method is defined below
                    //RewriteConnectionStringAndUpdateConfigFile(f, dataSource);

                    this.dataGridView1.DataSource = t;
                }
                else
                    Console.WriteLine("Source must be changed manually");
            }
            finally
            {
                Cursor.Current = Cursors.Default;
            }
        }
    }
}